#!/usr/bin/env python3

import os, random, hashlib, textwrap, json
from Crypto.Cipher import AES
from Crypto.Util.Padding import pad, unpad
from Crypto.Util.number import getPrime, long_to_bytes

from fastecdsa.curve import secp256k1
from fastecdsa.point import Point

CURVE = secp256k1
ORDER = CURVE.q
G = CURVE.G

from pwn import *
import os, time, json

HOST = sys.argv[1]
PORT = sys.argv[2]

io = remote(HOST, PORT)

io.recvuntil('Alice sends public key                    *\n****************************************************************\n\n\n')

AA = json.loads(io.recvuntil('}').decode('utf-8'))
PAlice = Point(AA['Px'], AA['Py'], curve=secp256k1)

io.recvuntil('Send to Bob: ')

nonce_bob = random.randint(2**64, 2**65)
T = G * nonce_bob

# print("Sending to Bob: {}".format(json.dumps({"nonce" : nonce_bob, "Px" : T.x, "Py" : T.y})))
io.sendline(json.dumps({"nonce" : nonce_bob, "Px" : T.x, "Py" : T.y}))


io.recvuntil('Bob sends public key                     *\n****************************************************************\n\n\n')

BB = json.loads(io.recvuntil('}').decode('utf-8'))
PBob = Point(BB['Px'], BB['Py'], curve=secp256k1)

io.recvuntil('Send to Alice: ')

nonce_alice = (PAlice * nonce_bob).x ^ (PBob * nonce_bob).x ^ nonce_bob
key = (PBob * nonce_bob).x ^ nonce_bob
# print("KEY: ", key)

# print("Sending to Alice: {}".format(json.dumps({"nonce" : nonce_alice, "Px" : T.x, "Py" : T.y})))
io.sendline(json.dumps({"nonce" : nonce_alice, "Px" : T.x, "Py" : T.y}))


io.recvuntil("Alice sends encrypted flag to Bob               *\n****************************************************************\n\n\n")

data = json.loads(io.recvuntil('}').decode('utf-8'))
# print("data: {}".format(json.dumps(data)))

def decrypt_flag(shared_secret: int, iv, encrypted_flag):
    key = hashlib.sha1(long_to_bytes(shared_secret)).digest()[:16]
    cipher = AES.new(key, AES.MODE_CBC, bytes.fromhex(iv))
    ciphertext = cipher.decrypt(bytes.fromhex(encrypted_flag))

    print(ciphertext.decode('utf-8'))

decrypt_flag(key, data['iv'], data['encrypted_flag'])